#ifndef LAMBDA_H
#define LAMBDA_H

#include <string.h>
#include <set>
#include <stdlib.h>
#include <stdio.h>
#include <cmath>
#include <iostream>
#include <vector>
#include <map>

using namespace std;

class FrequencyProfile{
    private: 
        int n_of_lmers;
        int * lmer_counts;
        double lambda0;
        double lambda1;
        double n_of_events0;
        double n_of_events1;
        string fin_counts;
        string fin_freq_distr;
        int count_threshold;
        int lower_count_threshold;
        map<int,int> frequency;
    public:  
        FrequencyProfile(string _fin_counts, string _fin_freq_distr, int _n_of_lmers);
        void estimPoisson();
        int findThreshold(double lambda, int n_of_events);
        void fillFreqDistribution();
        void fillLmers();
        void findThresholds();
        int findLowerThreshold(double lambda, int n_of_events);
        int UpperT();
        int LowerT();
        double getLambda();
};


#endif
