#ifndef MCLANALYZER_H
#define MCLANALYZER_H

#include <string.h>
#include <set>
#include <stdlib.h>
#include <stdio.h>
#include <cmath>
#include <iostream>
#include <vector>
#include <map>

using namespace std;

class MclOutput{
    private: 
        string cluster_info;
        string mcl_output_fname;
        string mgraph_fname;
        string final_mclusters;

        int n_clusters; 
        int * cluster_size;
        int * cluster_in_mcluster;
       
        double mcl_parameter; 
        static double mcl_parameter_start_vlaue;       
        static int big_cluster_size;
      

        int ** mcluster_graph;
        int n_clusters_mcl;
        set <int> * mcl_cluster; 
        int ** mgraph;
        static string mcl_path;
        string abundancebin_dir_prefix;
        
    public: 
        MclOutput(string _dir, int _bin, int _big_cluster_size);
        void loadClustersInformation();
        void getNOfMclClusters();
        void loadMclCLusters();
        void loadMGraph();
        int analyzeClusters(int &number_of_big_clusters, 
           int &number_of_big_good_clusters);
        void fillMclCluster(vector<string> &line, int &m_cluster);
        void fillMGraph(vector<string> &line);
        int isBig(int mclust_i);
        int isGood(int i, int &contin);
        double findMclParametr();  
        void runMcl(); 
        void iterateMcl(); 
        void outputMClusters();      
};


#endif
