#include <sstream>
#include <iostream>
#include <cstdlib>
#include <string>
#include <sys/stat.h>
#include <sys/types.h>
#include "MainProfile.h"

using namespace std;

void PrintHelp() 
{
  cerr << "Help: TOSS_final  output_directory  number_of_bins" << endl;
}

void ParseOptions(int argc, char **argv, string &dir, int &ab_n_bins) 
{
    if (argc == 3) 
    {

        stringstream n_bins(argv[2]);
        if ((n_bins >> ab_n_bins).fail()) 
        {
            cerr << "Error: number of bins is not an integer" << endl;
            PrintHelp();
            exit(1);
        }

        stringstream s_dir(argv[1]);
        if ((s_dir >> dir).fail()) 
        {
            cerr << "Error: output_directory is not a string" << endl;
            PrintHelp();
            exit(1);
        }
    } 
    else 
    {
        PrintHelp();
        exit(1);
    }
}

void FinalToss(string dir, int &ab_n_bins)
{
    MainProfile mp(dir, ab_n_bins);
    mp.checkDir();
    mp.inputBadBins();
    for (int i = 0; i < ab_n_bins; i++)
        mp.finalReadsClustering(i);
}

int main(int argc, char **argv) 
{
    int ab_n_bins; 
    string dir;

    ParseOptions(argc,argv,dir, ab_n_bins);
    FinalToss(dir,ab_n_bins);
}


