#include <sstream>
#include <iostream>
#include <cstdlib>
#include <string>
#include <sys/stat.h>
#include <sys/types.h>
#include "MclAnalyzer.h"

using namespace std;

void PrintHelp() 
{
  cerr << "Help: TOSS_mcl  output_directory  bin_number  big_cluster_size" << endl;
}

void ParseOptions(int argc, char **argv, string &dir, int &ab_n_bins, int &big_cluster_size) 
{
    if (argc == 4) 
    {
        stringstream s_dir(argv[1]);
        if ((s_dir >> dir).fail()) 
        {
            cerr << "Error: output_directory is not a string" << endl;
            PrintHelp();
            exit(1);
        }

        stringstream n_bins(argv[2]);
        if ((n_bins >> ab_n_bins).fail()) 
        {
            cerr << "Error: bin number is not an integer" << endl;
            PrintHelp();
            exit(1);
        }   

        stringstream big_c(argv[3]);
        if ((big_c >> big_cluster_size).fail()) 
        {
            cerr << "Error: big_cluster_size is not an integer" << endl;
            PrintHelp();
            exit(1);
        }         
    } 
    else 
    {
        PrintHelp();
        exit(1);
    }
}

void RunTossMcl(string dir, int &ab_n_bins, int &big_cluster_size)
{
    MclOutput mo(dir,ab_n_bins,big_cluster_size);
    mo.iterateMcl();
    mo.outputMClusters();
}

int main(int argc, char **argv) 
{
    int ab_n_bins, big_cluster_size; 
    string dir;

    ParseOptions(argc,argv,dir,ab_n_bins,big_cluster_size);
    RunTossMcl(dir,ab_n_bins,big_cluster_size);
}



